unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  AnzahlFragen = 4;

  Fragen: array[0..AnzahlFragen-1] of string = (
    'Mögen Sie Kino?',
    'Gehen Sie gerne ins Konzert?',
    'Gehen Sie gerne ins Theater?',
    'Wie gerne hören Sie Radio?'
  );


{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  Werte: TStringArray;
  Ergebnisse: Array[0..AnzahlFragen-1] of double;
  F: TextFile;
  Zeile: String;
  n, i, j, k: Integer;
  m: AnsiString;
begin
  // Zunächst die Elemente des Ergebnisse-Arrays für die Summenbildung auf 0 setzen
  for j := 0 to AnzahlFragen-1 do
    Ergebnisse[j] := 0;

  n:=4; //StrToInt(Edit1.Text);
  m:='0';
  k:=0;
  i:=0;
  repeat
    i:=i+1;
    k:=k+1;
    m:=IntToStr(k);
    AssignFile(F, 'daten\'+m+'.txt'); //Weist F die Datei zu
    Reset(F); //Öffnet die Datei zum lesen

    while not EOF(F) do
    begin
      ReadLn(F, Zeile);
      Werte := Zeile.Split(';');
      for j := 0 to AnzahlFragen-1 do
        Ergebnisse[j] := StrToInt(Werte[j]) + Ergebnisse[j];
    end;
    CloseFile(F);
  until i=n;

  // Mittelwerte berechnen
  for j := 0 to AnzahlFragen-1 do
    Ergebnisse[j] := Ergebnisse[j] / n;

  // Für die Ausgabe ist es flexibler, wenn du keine einzelnen Labels verwendest,
  // sondern z.B. ein TStringGrid

  // Anzahl der Zeilen im Grid festlegen
  StringGrid1.RowCount := StringGrid1.FixedRows + AnzahlFragen;
  // Anzahl der Spalten im Grid festlegen
  StringGrid1.ColCount := 2;
  // Titelzeile ausfüllen
  StringGrid1.Cells[0, 0] := 'Frage';
  StringGrid1.Cells[1, 0] := 'Mittelwert';
  // 1.Spalte breiter machen, so dass der Text nicht abgeschnitten wird
  StringGrid1.ColWidths[0] := 200;
  // Ergebnisse ins Grid eintragen
  for j := 0 to AnzahlFragen-1 do
  begin
    StringGrid1.Cells[0, j+StringGrid1.FixedRows] := Fragen[j];
    StringGrid1.Cells[1, j+StringGrid1.FixedCols] := FormatFloat('0.00', Ergebnisse[j]);
  end;
  // Grid anzeigen (ist, um Verwirrung zu vermeiden, zu Beginn ausgeblendet)
  StringGrid1.Visible := true;
end;

end.

